#include "client-ui.h"

ClientUI *client_ui_new(void) {

	ClientUI *new = (ClientUI*)g_malloc(sizeof(ClientUI));

	new->app = NULL;

	new->loaded_modules = module_hash_new();

	return new;

}

void client_ui_destroy_cb(GtkWidget *widget,gpointer data) {

  client_ui_destroy((ClientUI*)data);

}

void client_ui_destroy(ClientUI* ui) {
  
  g_print("destroying ui->app\n");
  gtk_widget_destroy(ui->app);
  
  g_print("unloading ui->loaded_modules\n");
  module_hash_destroy(ui->loaded_modules);

  g_free(ui);
  gtk_main_quit();
  
}

void client_ui_init(ClientUI *ui) {
  
  gchar *str1,*str2;
  
  if(ui == NULL) {
    ui = (ClientUI*)g_malloc(sizeof(ClientUI));
  }
  
  ui->app = 
    gnome_app_new((str1=g_strconcat(PACKAGE," client",NULL)),
		  (str2=g_strconcat(PACKAGE," client - ",VERSION,NULL)));
  
  gtk_signal_connect(GTK_OBJECT(ui->app),"destroy",
		     GTK_SIGNAL_FUNC(client_ui_destroy_cb),ui);
  
  gtk_widget_show(ui->app);
  
  g_free(str1);
  g_free(str2);
  
}
