#ifndef QUEST_CLIENT_UI_H
#define QUEST_CLIENT_UI_H

#include <config.h>
#include <gnome.h>
#include <modules.h>

/* this structure is used to gather all the widgets and datastructures
 * that are needed by the quest client program,
 * if you need to add a button to the client, just add it to this struct,
 * so that you can free the memory easily when you quit the client.
 */
typedef struct ClientUI {

  GtkWidget *app;
  GHashTable *loaded_modules;

} ClientUI;

/* this is a global variable, so that you can access the same ClientUI*
 * from every source file that includes this header file...
 */
ClientUI *client_ui;

/* allocates a new ClientUI and clears all its fields */
ClientUI *client_ui_new(void);

/* frees a ClientUI and all its fields */
void client_ui_destroy(ClientUI *ui);

/* this is a callback function that triggers client_ui_destroy */
void client_ui_destroy_cb(GtkWidget *widget,gpointer data);

/* sets up the fields of a ClientUI, creates the widgets etc. */
void client_ui_init(ClientUI* ui);

#endif /* QUEST_CLIENT_UI_H */
