#ifndef QUEST_MODULES_H
#define QUEST_MODULES_H

#include <gnome.h>
#include <gmodule.h>

/* these two functions are used by module_hash_new()
 */
gint gmodule_compare_func(gconstpointer a,gconstpointer b);
gboolean gmodule_remove_func(gpointer key,gpointer value,gpointer user_data);

/* these are two functions that you can use to create and destroy
 * a hash table to keep track of your loaded GModule*'s
 */
GHashTable *module_hash_new(void);
void module_hash_destroy(GHashTable *hash);

/* hash is a pointer to a hash table that keeps track of all the loaded
 * modules hashed by their filename including path.
 * you can either pass the hash table where you store your GModule*'s
 * or NULL, in which case the module is unloaded again after use.
 * don't worry about closing a module you will need in the future this
 * way, because the GLIB module system supports reference counting.
 */
gboolean call_func(GHashTable *hash,
		   const gchar *dir,const gchar *lib,const gchar *func,
		   const gint argc, const gpointer argv[]);

#endif /* QUEST_MODULES_H */
